/* ***************
// orkutbar.js
// Orkut Toolbar main JS file.
//
// Author: Renato Rodrigues (rraver@ig.com.br)
//
// Uses code from BBCode by Jed Brown 
// <http://jedbrown.net/mozilla/>
//
****************** */

var OBCode_stringBundle;
var OBCode_Document = null;

var obcode = {
  init: function() {
    OBCode_setupDocument(document);
  },
  
  obHide: function() {
	var bar=document.getElementById("orkut-toolbar");
	var btnShow=document.getElementById("btn_obShow");
	bar.setAttribute("collapsed",true);
	btnShow.setAttribute("collapsed",false);
},
  
  obShow: function() {
	var bar=document.getElementById("orkut-toolbar");
	var btnShow=document.getElementById("btn_obShow");
	bar.setAttribute("collapsed",false);
	btnShow.setAttribute("collapsed",true);
  },
  
  obcode: function(myCommand, codeType) {

    var str = null;

    var theBox = document.commandDispatcher.focusedElement;
    var oPosition = theBox.scrollTop;
    var oHeight = theBox.scrollHeight;
    
    
    //Get Selected text (if selected)
      var startPos = theBox.selectionStart;
      var endPos = theBox.selectionEnd;
      str = theBox.value.substring(startPos, endPos);

	  str_clipboard = null

      //alert("Str: " +str);
 
      if(codeType == "obcode"){
        obcode.insertAtCursorSetup(myCommand, str_clipboard, str, theBox);
      }else if(codeType == "obcode-color"){
        obcode.insertAtCursorSetup('color', myCommand, str, theBox);
      }else if(codeType == "obcode-emoticon"){
        obcode.insertAtCursor(theBox, " " + myCommand + " ");
      }else{
        alert("Error #1");
      }
    var nHeight = theBox.scrollHeight - oHeight;
    theBox.scrollTop = oPosition + nHeight;
  },
  
    insertAtCursorSetup: function(myCommand, str_clipboard, str, theBox) {
  // Function taken from http://www.alexking.org/blog/2003/06/02/inserting-at-the-cursor-using-javascript/
  // Modified to return cursor to correct place

    switch (myCommand){

      case "bold":
        obcode.insertAtCursor(theBox,"[b]" + str + "[/b]");
      break;
        
      case "italic":
        obcode.insertAtCursor(theBox,"[i]" + str + "[/i]");
      break;
        
      case "underline":
        obcode.insertAtCursor(theBox,"[u]" + str + "[/u]");
      break;
        
      case "color":
        obcode.insertAtCursor(theBox,"[" + str_clipboard + "]" + str + "[/" + str_clipboard + "]");
      break;

      case "linkABC":

		linkText = OBCode_stringBundle.getString("obcode.linkABC");
		str_link = prompt(linkText,"http://");

		if (str_link) {
	      if(str){
    	    obcode.insertAtCursor(theBox,"[link=" + str_link + "]" + str + "[/link]");
	      }else{
    	     obcode.insertAtCursor(theBox,"[link]" + str_link + "[/link]");
	      }
		}

  	  break;

      case "linkWWW":

		linkText = OBCode_stringBundle.getString("obcode.linkWWW");
		str_link = prompt(linkText,"http://");
		  if (str_link) {
	      	obcode.insertAtCursor(theBox,"[link]" + str_link + "[/link]");
  	 	  }
   	  break;

      case "obSign":
		obSign = OBCode_stringBundle.getString("obcode.obSign");
        obcode.insertAtCursor(theBox,obSign);
      break;

         //End obcode
        
      default : 
        alert("Error #2");
    }
  },

  //Thanks to Nick for pointing out this function
  insertAtCursor: function(theBox, aText) {
    try {
      var command = "cmd_insertText";
      var controller = document.commandDispatcher.getControllerForCommand(command);
      if (controller && controller.isCommandEnabled(command)) {
        controller = controller.QueryInterface(Components.interfaces.nsICommandController);
        var params = Components.classes["@mozilla.org/embedcomp/command-params;1"];
        params = params.createInstance(Components.interfaces.nsICommandParams);
        params.setStringValue("state_data", aText);
        controller.doCommandWithParams(command, params);
      }
    }catch (e) {
      dump("Can't do cmd_insertText! ");
      dump(e+"\n")
    }
  },
} 

//May not be needed, but just incase.
function OBCode_setupDocument(aDoc)
{
  OBCode_Document = aDoc;
  OBCode_stringBundle = aDoc.getElementById("obstrings");
}

//Make sure OBCode loads on start-up of browser.
window.addEventListener('load', obcode.init, false); 
